// Calculadora con la libreria WX
// SETA43
// windows -linux 

#include <wx/wx.h>

#include "define.h"
 
char VARI[100];

time_t hora;
struct tm *phora;

int tiempo=0;

static char meses[][12]= {"Enero","Febrero","Marzo","Abril","Mayo","Junio","Julio","Agosto","Septiembre","Octubre","Noviembre","Diciembre"};



class calc2App : public wxApp
{
public:
    virtual bool OnInit();
};

class calc2Frame: public wxFrame
{
public:
    calc2Frame(wxWindow* parent,wxWindowID id = -1);

private:
    DECLARE_EVENT_TABLE()

    void OnQuit(wxCommandEvent& event);
    void OnAbout(wxCommandEvent& event);
    void MiTimer(wxTimerEvent& event);
    
    
    //(*Identifiers(calc2Frame)
    static const long ID_BUTTON2;
    

		wxButton* Button1;
        wxStaticText* StaticText1;
        wxTextCtrl* TextCtrl2;
        wxTextCtrl* TextCtrl1;
    
    
};


bool calc2App::OnInit()
{
    calc2Frame* Frame = new calc2Frame(0);
    Frame->Show();
    return true;
}


DECLARE_APP(calc2App)
// Give wxWidgets the means to create a MiAplicacion object
IMPLEMENT_APP(calc2App)

BEGIN_EVENT_TABLE(calc2Frame,wxFrame)

    EVT_BUTTON(1000, calc2Frame::OnQuit)
    EVT_TIMER(1001, calc2Frame::MiTimer)
    EVT_MENU(wxID_ABOUT, calc2Frame::OnAbout)
    EVT_MENU(wxID_EXIT, calc2Frame::OnQuit)

END_EVENT_TABLE();

calc2Frame::calc2Frame(wxWindow* parent,wxWindowID id)
{
//(*Initialize(calc2Frame)
    wxMenuItem* MenuItem2;
    wxMenuItem* MenuItem1;
    wxMenu* Menu1;
    wxMenuBar* MenuBar1;
    wxMenu* Menu2;

    Create(parent, id, _("Mi wxReloj"), wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE, _T("id"));
	this->SetBackgroundColour( wxColour( 255, 255, 176 ) );
	
#if YesWindows
            SetClientSize(wxSize(216,250));
			SetMinSize(wxSize(216,250));
			SetMaxSize(wxSize(216,250));
#else		
		    SetClientSize(wxSize(206,222));
			SetMinSize(wxSize(206,222));
			SetMaxSize(wxSize(206,222));
#endif	
	
	TextCtrl1 = new wxTextCtrl(this, 1010, _("00:00:00"), wxPoint(8,48), wxSize(192,40), wxTE_CENTRE, wxDefaultValidator, _T("ID_TEXTCTRL1"));
    wxFont TextCtrl1Font(28,wxTELETYPE,wxFONTSTYLE_NORMAL,wxNORMAL,false,_T("Courier 10 Pitch"),wxFONTENCODING_DEFAULT);
    TextCtrl1->SetFont(TextCtrl1Font);
    TextCtrl2 = new wxTextCtrl(this, 1011, _("Fecha"), wxPoint(16,104), wxSize(176,24), wxTE_CENTRE, wxDefaultValidator, _T("ID_TEXTCTRL2"));
    StaticText1 = new wxStaticText(this, 1012, _("wxReloj"), wxPoint(64,16), wxSize(96,32), 0, _T("ID_STATICTEXT1"));
    wxFont StaticText1Font(16,wxSWISS,wxFONTSTYLE_NORMAL,wxNORMAL,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    StaticText1->SetFont(StaticText1Font);
    Button1 = new wxButton(this, 1000, _("Salir"), wxPoint(56,160), wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
    MenuBar1 = new wxMenuBar();
    Menu1 = new wxMenu();
    MenuItem1 = new wxMenuItem(Menu1, wxID_EXIT, _("Salir\tAlt-F4"), _("Quit the application"), wxITEM_NORMAL);
    Menu1->Append(MenuItem1);
    MenuBar1->Append(Menu1, _("&Menu"));
    Menu2 = new wxMenu();
    MenuItem2 = new wxMenuItem(Menu2, wxID_ABOUT, _("Acerca\tF1"), _("Show info about this application"), wxITEM_NORMAL);
    Menu2->Append(MenuItem2);
    MenuBar1->Append(Menu2, _("Ayuda"));
    SetMenuBar(MenuBar1);

    wxTimer *MiTimer= new wxTimer();
    MiTimer->SetOwner(this, 1001); //identificador de evento
    MiTimer->Start(1000);	// cada segundo
}


void calc2Frame::OnQuit(wxCommandEvent& event)
{
    Close();
}

void calc2Frame::OnAbout(wxCommandEvent& event)
{
    wxString msg;
    msg.Printf(wxT("wxReloj\nxsetaseta@gmail.com\n%s"),	wxVERSION_STRING);
    wxMessageBox(msg, wxT("SETA43"), wxOK | wxICON_INFORMATION, this);
}

void calc2Frame::MiTimer(wxTimerEvent& event)
{

    tiempo++;
	this->SetFocus();

    hora= time( NULL );
    phora = gmtime( &hora );

    //sprintf(VARI,"%dM%dD%dH%dM%dS",(phora->tm_mon+1),phora->tm_mday,phora->tm_hour,phora->tm_min, phora->tm_sec );
    sprintf(VARI,"%02d:%02d:%02d",phora->tm_hour,phora->tm_min, phora->tm_sec );
    wxString  msg(VARI, wxConvUTF8);
    TextCtrl1->SetValue(msg);

    //sprintf(VARI,"%d-%d-%d",phora->tm_mday,(phora->tm_mon+1), (phora->tm_year+1900));
    sprintf(VARI,"%d-%s-%d",phora->tm_mday,meses[(phora->tm_mon)], (phora->tm_year+1900));
    wxString string1(VARI, wxConvUTF8);
    TextCtrl2->SetValue(string1);

}
