/***************************************************************
 * Name:      wxReloj2Main.cpp
 * Purpose:   Code for Application Frame
 * Author:     ()
 * Created:   2014-07-02
 * Copyright:  ()
 * License:
 **************************************************************/

#include "wxReloj2Main.h"
#include <wx/msgdlg.h>

//(*InternalHeaders(wxReloj2Frame)
#include <wx/font.h>
#include <wx/intl.h>
#include <wx/string.h>
//*)

char VARI[100];

time_t hora;
struct tm *phora;

int tiempo=0;

static char meses[][12]= {"Enero","Febrero","Marzo","Abril","Mayo","Junio","Julio","Agosto","Septiembre","Octubre","Noviembre","Diciembre"};




//helper functions
enum wxbuildinfoformat
{
    short_f, long_f
};

wxString wxbuildinfo(wxbuildinfoformat format)
{
    wxString wxbuild(wxVERSION_STRING);

    if (format == long_f )
    {
#if defined(__WXMSW__)
        wxbuild << _T("-Windows");
#elif defined(__UNIX__)
        wxbuild << _T("-Linux");
#endif

#if wxUSE_UNICODE
        wxbuild << _T("-Unicode build");
#else
        wxbuild << _T("-ANSI build");
#endif // wxUSE_UNICODE
    }

    return wxbuild;
}

//(*IdInit(wxReloj2Frame)
const long wxReloj2Frame::ID_TEXTCTRL1 = wxNewId();
const long wxReloj2Frame::ID_TEXTCTRL2 = wxNewId();
const long wxReloj2Frame::ID_STATICTEXT1 = wxNewId();
const long wxReloj2Frame::ID_BUTTON1 = wxNewId();
const long wxReloj2Frame::idMenuQuit = wxNewId();
const long wxReloj2Frame::idMenuAbout = wxNewId();
//*)

BEGIN_EVENT_TABLE(wxReloj2Frame,wxFrame)
    //(*EventTable(wxReloj2Frame)
    //*)
    EVT_TIMER(1000, wxReloj2Frame::MiTimer)
END_EVENT_TABLE()

wxReloj2Frame::wxReloj2Frame(wxWindow* parent,wxWindowID id)
{
    //(*Initialize(wxReloj2Frame)
    wxMenuItem* MenuItem2;
    wxMenuItem* MenuItem1;
    wxMenu* Menu1;
    wxMenuBar* MenuBar1;
    wxMenu* Menu2;

    Create(parent, id, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE, _T("id"));
    SetClientSize(wxSize(206,222));
    TextCtrl1 = new wxTextCtrl(this, ID_TEXTCTRL1, _("00:00:00"), wxPoint(8,48), wxSize(192,40), wxTE_CENTRE, wxDefaultValidator, _T("ID_TEXTCTRL1"));
    wxFont TextCtrl1Font(28,wxTELETYPE,wxFONTSTYLE_NORMAL,wxNORMAL,false,_T("Courier 10 Pitch"),wxFONTENCODING_DEFAULT);
    TextCtrl1->SetFont(TextCtrl1Font);
    TextCtrl2 = new wxTextCtrl(this, ID_TEXTCTRL2, _("Fecha"), wxPoint(16,104), wxSize(176,24), wxTE_CENTRE, wxDefaultValidator, _T("ID_TEXTCTRL2"));
    StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _("wxReloj"), wxPoint(64,16), wxSize(96,32), 0, _T("ID_STATICTEXT1"));
    wxFont StaticText1Font(16,wxSWISS,wxFONTSTYLE_NORMAL,wxNORMAL,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    StaticText1->SetFont(StaticText1Font);
    Button1 = new wxButton(this, ID_BUTTON1, _("Salir"), wxPoint(56,160), wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
    MenuBar1 = new wxMenuBar();
    Menu1 = new wxMenu();
    MenuItem1 = new wxMenuItem(Menu1, idMenuQuit, _("Salir\tAlt-F4"), _("Quit the application"), wxITEM_NORMAL);
    Menu1->Append(MenuItem1);
    MenuBar1->Append(Menu1, _("&Menu"));
    Menu2 = new wxMenu();
    MenuItem2 = new wxMenuItem(Menu2, idMenuAbout, _("Acerca\tF1"), _("Show info about this application"), wxITEM_NORMAL);
    Menu2->Append(MenuItem2);
    MenuBar1->Append(Menu2, _("Ayuda"));
    SetMenuBar(MenuBar1);

    Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&wxReloj2Frame::OnQuit);
    Connect(idMenuQuit,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&wxReloj2Frame::OnQuit);
    Connect(idMenuAbout,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&wxReloj2Frame::OnAbout);

    wxTimer *MiTimer= new wxTimer();
    MiTimer->SetOwner(this, 1000);
    MiTimer->Start(1000);	// 20 veces por Segundo
    //*)
}

wxReloj2Frame::~wxReloj2Frame()
{
    //(*Destroy(wxReloj2Frame)
    //*)
}

void wxReloj2Frame::OnQuit(wxCommandEvent& event)
{
    Close();
}

void wxReloj2Frame::OnAbout(wxCommandEvent& event)
{
    wxString msg = wxbuildinfo(long_f);
    wxMessageBox(msg, _("wxReloj  SETA43"));
}

void wxReloj2Frame::MiTimer(wxTimerEvent& event)
{

    tiempo++;

    hora= time( NULL );
    phora = gmtime( &hora );

    //sprintf(VARI,"%dM%dD%dH%dM%dS",(phora->tm_mon+1),phora->tm_mday,phora->tm_hour,phora->tm_min, phora->tm_sec );
    sprintf(VARI,"%02d:%02d:%02d",phora->tm_hour,phora->tm_min, phora->tm_sec );
    wxString  msg(VARI, wxConvUTF8);
    TextCtrl1->SetValue(msg);

    //sprintf(VARI,"%d-%d-%d",phora->tm_mday,(phora->tm_mon+1), (phora->tm_year+1900));
    sprintf(VARI,"%d-%s-%d",phora->tm_mday,meses[(phora->tm_mon)], (phora->tm_year+1900));
    wxString string1(VARI, wxConvUTF8);
    TextCtrl2->SetValue(string1);

}
